extends Node


var Difficulty = [
	"Easy",
	"Normal",
	"Hard"
]
var Selection = [
	0,
	0,
	0,
	0,
	0
]


# Called when the node enters the scene tree for the first time.
func _ready():
	get_node("Control/VBoxContainer/Title").grab_focus()

# Called every frame. 'delta' is the elapsed time since the previous frame.
#func _process(delta):
#	pass


func _on_Timer_timeout():
	var node = get_node("Control/VBoxContainer/Info")
	node.visible = !node.visible


func _on_Title_gui_input(event):
	update_title(event)
func _on_Players_gui_input(event):
	update_options(event, 0, [1,2])
func _on_Player1_gui_input(event):
	update_options(event, 1, ["Easy", "Normal", "Hard"])
func _on_Player2_gui_input(event):
	update_options(event, 2, ["Easy", "Normal", "Hard"])
func _on_Player3_gui_input(event):
	update_options(event, 3, ["Easy", "Normal", "Hard"])		
func _on_Player4_gui_input(event):
	update_options(event, 4, ["Easy", "Normal", "Hard"])


func update_title(event:InputEvent):
	if event.is_action_pressed("p1_a") && has_node("Control/Panel/VBoxContainer2/Players"):
		get_node("AnimationPlayer").play("show")
		yield(get_node("AnimationPlayer"), "animation_finished")
		get_node("Control/Panel/VBoxContainer2/Players").grab_focus()
	

func update_options(event:InputEvent, index:int, options:Array):
	var node = get_node("Control/Panel/VBoxContainer2").get_child(index)
	
	node.get_node("Value").text.rstrip(str(options[Selection[index]%Difficulty.size()]))
	if event.is_action_pressed("p1_left"):
		Selection[index]-=1
	if event.is_action_pressed("p1_right"):
		Selection[index]+=1
		
	Selection[index] %= get_node("Control/Panel/VBoxContainer2").get_child_count()
	node.get_node("Value").text = str(options[Selection[index]%Difficulty.size()])
	
	if event.is_action_pressed("p1_b"):
		get_node("AnimationPlayer").play("hide")
		yield(get_node("AnimationPlayer"), "animation_finished")
		get_node("Control/VBoxContainer/Title").grab_focus()
