extends CenterContainer
tool


export var id      : String          setget _set_id 
export var font    : Font            setget _set_font
export var option  : int             setget _set_option
export var options : PoolStringArray setget _set_options
export var flash_speed : float       setget _set_flash_speed
export var focus_alpha : float       setget _set_focus_alpha

func _set_id (value):
	var node
	id  = value;
	if has_node("HBoxContainer/Name"):
		node = get_node("HBoxContainer/Name")	
		if (id == "" || options.size() == 0 || options[option%options.size()] == ""):
			node.text = id + ""
		else:
			node.text = id + ":"

func _set_font(value):
	var node1
	var node2
	font = value
	if has_node("HBoxContainer/Name") && has_node("HBoxContainer/Value"):
		node1 = get_node("HBoxContainer/Name")
		node2 = get_node("HBoxContainer/Value")	
		node1.set("custom_fonts/font", value)
		node2.set("custom_fonts/font", value)


func _set_option(value):
	var node1
	var node2
	option = value
	if has_node("HBoxContainer/Name") && has_node("HBoxContainer/Value"):
		node1 = get_node("HBoxContainer/Name")
		node2 = get_node("HBoxContainer/Value")	

		if (id == "" || options.size() == 0 || options[option%options.size()] == ""):
			node1.text = id + ""
		else: 
			node1.text = id + ":"
			
		if (options.size() <= 0):
			node2.text = ""
			return
			
		node2.text = options[option%options.size()]
	
func _set_options(value):
	var node1
	var node2
	options = value
	if has_node("HBoxContainer/Name") && has_node("HBoxContainer/Value"):
		node1 = get_node("HBoxContainer/Name")
		node2 = get_node("HBoxContainer/Value")	

		if (id == "" || options.size() == 0 || options[option%options.size()] == ""):
			node1.text = id + ""
		else:
			node1.text = id + ":"

		if (options.size() <= 0):
			node2.text = ""
			return
			
		node2.text = options[option%options.size()]

func _set_flash_speed(value):
	var node
	flash_speed = value
	if has_node("Timer"):
		node = get_node("Timer")	

		if (flash_speed <= 0):
			node.pause_mode = Node.PAUSE_MODE_STOP
			return
		node.pause_mode = Node.PAUSE_MODE_INHERIT
		node.wait_time = value
		
func _set_focus_alpha(value):
	var node
	focus_alpha = value
	if has_node("ColorRect"):
		node = get_node("ColorRect")	
		node.modulate.a = value
		
func _on_Option_focus_entered():
	get_node("ColorRect").visible = true


func _on_Option_focus_exited():
	get_node("ColorRect").visible = false


func _on_Timer_timeout():
	if (flash_speed > 0):
		get_node("HBoxContainer/Name").visible  = !get_node("HBoxContainer/Name").visible 
		get_node("HBoxContainer/Value").visible = !get_node("HBoxContainer/Value").visible 
		get_node("ColorRect").visible = !get_node("ColorRect").visible 
